package com.steerinfo.util;

import java.math.BigDecimal;

/**
 * DOUBLE高精度操作类
 * */
public class DoubleUtil {
	//默认除法运算精度
	public static final int DEF_DIV_SCALE = 4;
	
	//默认金额2位精度
	public static final int SCALE_PRICE = 2;
	
	//默认重量3位精度
	public static final int SCALE_WGT = 3;

	//这个类不能实例化
	private DoubleUtil(){
	}

	/**
	 * 提供精确的加法运算。
	 * @param v1 被加数
	 * @param v2 加数
	 * @return 两个参数的和
	 */
	public static double add(double v1,double v2){
		BigDecimal b1 = new BigDecimal(Double.toString(v1));
		BigDecimal b2 = new BigDecimal(Double.toString(v2));
		return b1.add(b2).doubleValue();
	}

	/**
	 * 提供精确的减法运算。
	 * @param v1 被减数
	 * @param v2 减数
	 * @return 两个参数的差
	 */
	public static double sub(double v1,double v2){
		BigDecimal b1 = new BigDecimal(Double.toString(v1));
		BigDecimal b2 = new BigDecimal(Double.toString(v2));
		return b1.subtract(b2).doubleValue();
	}

	/**
	 * 提供精确的乘法运算。
	 * @param v1 被乘数
	 * @param v2 乘数
	 * @return 两个参数的积
	 */
	public static double mul(double v1,double v2){
		BigDecimal b1 = new BigDecimal(Double.toString(v1));
		BigDecimal b2 = new BigDecimal(Double.toString(v2));
		return b1.multiply(b2).doubleValue();
	}

	/**
	 * 提供（相对）精确的除法运算，当发生除不尽的情况时，精确到
	 * 小数点以后10位，以后的数字四舍五入。
	 * @param v1 被除数
	 * @param v2 除数
	 * @return 两个参数的商
	 */
	public static double div(double v1,double v2){
		return div(v1,v2,DEF_DIV_SCALE);
	}

	/**
	 * 提供（相对）精确的除法运算。当发生除不尽的情况时，由scale参数指
	 * 定精度，以后的数字四舍五入。
	 * @param v1 被除数
	 * @param v2 除数
	 * @param scale 表示表示需要精确到小数点以后几位。
	 * @return 两个参数的商
	 */
	public static double div(double v1,double v2,int scale){
		if(scale<0){
			throw new IllegalArgumentException("The scale must be a positive integer or zero");
		}
		BigDecimal b1 = new BigDecimal(Double.toString(v1));
		BigDecimal b2 = new BigDecimal(Double.toString(v2));
		return b1.divide(b2,scale,BigDecimal.ROUND_HALF_UP).doubleValue();
	}

	/**
	 * 提供精确的小数位四舍五入处理。
	 * @param v 需要四舍五入的数字
	 * @param scale 小数点后保留几位
	 * @return 四舍五入后的结果
	 */
	public static double round(double v,int scale){
		if(scale<0){
			throw new IllegalArgumentException("The scale must be a positive integer or zero");
		}
		BigDecimal b = new BigDecimal(Double.toString(v));
		BigDecimal one = new BigDecimal("1");
		return b.divide(one,scale,BigDecimal.ROUND_HALF_UP).doubleValue();
	}
	
	/**
	 * 对Double型中默认保留.0的处理：【浮点型默认保留小数点】
	 * 比如：346.0-->346
	 * @param v 需要转换的数字
	 */
	public static Object rmZero(double v){
		String v_str=Double.toString(v);
		if(v_str.length()<2){
			return v;
		}else{
			if(".0".equals(v_str.substring(v_str.length()-2, v_str.length()))){
				v_str=v_str.substring(0, v_str.length()-2);
				//return Double.parseDouble(v_str);
				return Integer.parseInt(v_str);
			}else{
				return v;
			}
		}
	}
		
//	public static void main(String[] args){
//		Double v=346.0;
//		Double v1=346.01;
//		Object leo=DoubleUtil.rmZero(v);
//		Object leo1=DoubleUtil.rmZero(v1);
//		//system.out.println(leo);//346
//		//system.out.println(leo1);//346.01
//	}
	
} 
